diff --git a/python/macholib/doc/conf.py b/python/macholib/doc/conf.py
index 08a48f3ede..15cb669f18 100644
--- a/python/macholib/doc/conf.py
+++ b/python/macholib/doc/conf.py
@@ -1,4 +1,3 @@
-# -*- coding: utf-8 -*-
 #
 # macholib documentation build configuration file, created by
 # sphinx-quickstart on Tue Sep 28 22:23:35 2010.
@@ -52,8 +51,8 @@ source_suffix = '.rst'
 master_doc = 'index'
 
 # General information about the project.
-project = u'macholib'
-copyright = u'2010-2011, Ronald Oussoren'
+project = 'macholib'
+copyright = '2010-2011, Ronald Oussoren'
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
@@ -190,8 +189,8 @@ htmlhelp_basename = 'macholibdoc'
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('index', 'macholib.tex', u'macholib Documentation',
-   u'Ronald Oussoren', 'manual'),
+  ('index', 'macholib.tex', 'macholib Documentation',
+   'Ronald Oussoren', 'manual'),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
@@ -223,18 +222,18 @@ latex_documents = [
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
 man_pages = [
-    ('index', 'macholib', u'macholib Documentation',
-     [u'Ronald Oussoren'], 1)
+    ('index', 'macholib', 'macholib Documentation',
+     ['Ronald Oussoren'], 1)
 ]
 
 
 # -- Options for Epub output ---------------------------------------------------
 
 # Bibliographic Dublin Core info.
-epub_title = u'macholib'
-epub_author = u'Ronald Oussoren'
-epub_publisher = u'Ronald Oussoren'
-epub_copyright = u'2010, Ronald Oussoren'
+epub_title = 'macholib'
+epub_author = 'Ronald Oussoren'
+epub_publisher = 'Ronald Oussoren'
+epub_copyright = '2010, Ronald Oussoren'
 
 # The language of the text. It defaults to the language option
 # or en if the language is not set.
diff --git a/python/macholib/macholib/MachO.py b/python/macholib/macholib/MachO.py
index f83ddb7115..b227d9ab04 100644
--- a/python/macholib/macholib/MachO.py
+++ b/python/macholib/macholib/MachO.py
@@ -1,8 +1,8 @@
 """
 Utilities for reading and writing Mach-O headers
 """
-from __future__ import print_function
 
+from __future__ import print_function
 import sys
 import struct
 
@@ -15,19 +15,19 @@ except ImportError:
     pass
 
 try:
-    unicode
+    str
 except NameError:
-    unicode = str
+    str = str
 
 __all__ = ['MachO']
 
-_RELOCATABLE = set((
+_RELOCATABLE = {
     # relocatable commands that should be used for dependency walking
     LC_LOAD_DYLIB,
     LC_LOAD_WEAK_DYLIB,
     LC_PREBOUND_DYLIB,
     LC_REEXPORT_DYLIB,
-))
+}
 
 _RELOCATABLE_NAMES = {
     LC_LOAD_DYLIB: 'load_dylib',
@@ -42,7 +42,7 @@ def _shouldRelocateCommand(cmd):
     """
     return cmd in _RELOCATABLE
 
-class MachO(object):
+class MachO:
     """
     Provides reading/writing the Mach-O header of a specific existing file
     """
@@ -69,7 +69,7 @@ class MachO(object):
             self.load(fp)
 
     def __repr__(self):
-        return "<MachO filename=%r>" % (self.filename,)
+        return "<MachO filename={!r}>".format(self.filename)
 
     def load(self, fh):
         assert fh.tell() == 0
@@ -109,7 +109,7 @@ class MachO(object):
         elif header == MH_CIGAM_64:
             magic, hdr, endian = MH_CIGAM_64, mach_header_64, '<'
         else:
-            raise ValueError("Unknown Mach-O header: 0x%08x in %r" % (
+            raise ValueError("Unknown Mach-O header: 0x{:08x} in {!r}".format(
                 header, fh))
         hdr = MachOHeader(self, fh, offset, size, magic, hdr, endian)
         self.headers.append(hdr)
@@ -118,7 +118,7 @@ class MachO(object):
         for header in self.headers:
             header.write(f)
 
-class MachOHeader(object):
+class MachOHeader:
     """
     Provides reading/writing the Mach-O header of a specific existing file
     """
@@ -287,7 +287,7 @@ class MachOHeader(object):
     def changedHeaderSizeBy(self, bytes):
         self.sizediff += bytes
         if (self.total_size + self.sizediff) > self.low_offset:
-            print("WARNING: Mach-O header in %r may be too large to relocate"%(self.parent.filename,))
+            print(("WARNING: Mach-O header in %r may be too large to relocate"%(self.parent.filename,)))
 
     def rewriteLoadCommands(self, changefunc):
         """
@@ -338,7 +338,7 @@ class MachOHeader(object):
             cmd.to_fileobj(fileobj)
 
             if sys.version_info[0] == 2:
-                if isinstance(data, unicode):
+                if isinstance(data, str):
                     fileobj.write(data.encode(sys.getfilesystemencoding()))
 
                 elif isinstance(data, (bytes, str)):
@@ -388,7 +388,7 @@ def main(fn):
         for idx, name, other in header.walkRelocatables():
             if other not in seen:
                 seen.add(other)
-                print('\t' + name + ": " + other)
+                print(('\t' + name + ": " + other))
 
 if __name__ == '__main__':
     import sys
diff --git a/python/macholib/macholib/MachOGraph.py b/python/macholib/macholib/MachOGraph.py
index 8875c56eb5..45317e5bcb 100644
--- a/python/macholib/macholib/MachOGraph.py
+++ b/python/macholib/macholib/MachOGraph.py
@@ -16,30 +16,30 @@ from macholib.itergraphreport import itergraphreport
 __all__ = ['MachOGraph']
 
 try:
-    unicode
+    str
 except NameError:
-    unicode = str
+    str = str
 
-class MissingMachO(object):
+class MissingMachO:
     def __init__(self, filename):
         self.graphident = filename
         self.headers = ()
 
     def __repr__(self):
-        return '<%s graphident=%r>' % (type(self).__name__, self.graphident)
+        return '<{} graphident={!r}>'.format(type(self).__name__, self.graphident)
 
 class MachOGraph(ObjectGraph):
     """
     Graph data structure of Mach-O dependencies
     """
     def __init__(self, debug=0, graph=None, env=None, executable_path=None):
-        super(MachOGraph, self).__init__(debug=debug, graph=graph)
+        super().__init__(debug=debug, graph=graph)
         self.env = env
         self.trans_table = {}
         self.executable_path = executable_path
 
     def locate(self, filename, loader=None):
-        assert isinstance(filename, (str, unicode))
+        assert isinstance(filename, (str, str))
         if filename.startswith('@loader_path/') and loader is not None:
             fn = self.trans_table.get((loader.filename, filename))
             if fn is None:
@@ -63,8 +63,8 @@ class MachOGraph(ObjectGraph):
         return fn
 
     def findNode(self, name, loader=None):
-        assert isinstance(name, (str, unicode))
-        data = super(MachOGraph, self).findNode(name)
+        assert isinstance(name, (str, str))
+        data = super().findNode(name)
         if data is not None:
             return data
         newname = self.locate(name, loader=loader)
@@ -73,12 +73,12 @@ class MachOGraph(ObjectGraph):
         return None
 
     def run_file(self, pathname, caller=None):
-        assert isinstance(pathname, (str, unicode))
+        assert isinstance(pathname, (str, str))
         self.msgin(2, "run_file", pathname)
         m = self.findNode(pathname, loader=caller)
         if m is None:
             if not os.path.exists(pathname):
-                raise ValueError('%r does not exist' % (pathname,))
+                raise ValueError('{!r} does not exist'.format(pathname))
             m = self.createNode(MachO, pathname)
             self.createReference(caller, m, edge_data='run_file')
             self.scan_node(m)
@@ -86,7 +86,7 @@ class MachOGraph(ObjectGraph):
         return m
 
     def load_file(self, name, caller=None):
-        assert isinstance(name, (str, unicode))
+        assert isinstance(name, (str, str))
         self.msgin(2, "load_file", name)
         m = self.findNode(name)
         if m is None:
@@ -105,14 +105,14 @@ class MachOGraph(ObjectGraph):
         self.msgin(2, 'scan_node', node)
         for header in node.headers:
             for idx, name, filename in header.walkRelocatables():
-                assert isinstance(name, (str, unicode))
-                assert isinstance(filename, (str, unicode))
+                assert isinstance(name, (str, str))
+                assert isinstance(filename, (str, str))
                 m = self.load_file(filename, caller=node)
                 self.createReference(node, m, edge_data=name)
         self.msgout(2, '', node)
 
     def itergraphreport(self, name='G'):
-        nodes = map(self.graph.describe_node, self.graph.iterdfs(self))
+        nodes = list(map(self.graph.describe_node, self.graph.iterdfs(self)))
         describe_edge = self.graph.describe_edge
         return itergraphreport(nodes, describe_edge, name=name)
 
diff --git a/python/macholib/macholib/MachOStandalone.py b/python/macholib/macholib/MachOStandalone.py
index f8627336ce..85bdc804b3 100644
--- a/python/macholib/macholib/MachOStandalone.py
+++ b/python/macholib/macholib/MachOStandalone.py
@@ -11,21 +11,21 @@ class ExcludedMachO(MissingMachO):
 
 class FilteredMachOGraph(MachOGraph):
     def __init__(self, delegate, *args, **kwargs):
-        super(FilteredMachOGraph, self).__init__(*args, **kwargs)
+        super().__init__(*args, **kwargs)
         self.delegate = delegate
 
     def createNode(self, cls, name):
         cls = self.delegate.getClass(name, cls)
-        res = super(FilteredMachOGraph, self).createNode(cls, name)
+        res = super().createNode(cls, name)
         return res
 
     def locate(self, filename, loader=None):
-        newname = super(FilteredMachOGraph, self).locate(filename, loader)
+        newname = super().locate(filename, loader)
         if newname is None:
             return None
         return self.delegate.locate(newname)
 
-class MachOStandalone(object):
+class MachOStandalone:
     def __init__(self, base, dest=None, graph=None, env=None,
             executable_path=None):
         self.base = os.path.join(os.path.abspath(base), '')
@@ -144,4 +144,4 @@ class MachOStandalone(object):
                     flipwritable(fn, old_mode)
 
         allfiles = [mm.locate(node.filename) for node in machfiles]
-        return set(filter(None, allfiles))
+        return set([_f for _f in allfiles if _f])
diff --git a/python/macholib/macholib/SymbolTable.py b/python/macholib/macholib/SymbolTable.py
index 62fb172fda..ad4e1b81e7 100644
--- a/python/macholib/macholib/SymbolTable.py
+++ b/python/macholib/macholib/SymbolTable.py
@@ -8,7 +8,7 @@ __all__ = ['SymbolTable']
 
 # XXX: Does not support 64-bit, probably broken anyway
 
-class SymbolTable(object):
+class SymbolTable:
     def __init__(self, macho, openfile=None):
         if openfile is None:
             openfile = open
@@ -30,7 +30,7 @@ class SymbolTable(object):
         strtab = fh.read(cmd.strsize)
         fh.seek(cmd.symoff)
         nlists = []
-        for i in xrange(cmd.nsyms):
+        for i in range(cmd.nsyms):
             cmd = nlist.from_fileobj(fh)
             if cmd.n_un == 0:
                 nlists.append((cmd, ''))
@@ -72,18 +72,18 @@ class SymbolTable(object):
     def readtoc(self, fh, off, n):
         #print 'toc', off, n
         fh.seek(off)
-        return [dylib_table_of_contents.from_fileobj(fh) for i in xrange(n)]
+        return [dylib_table_of_contents.from_fileobj(fh) for i in range(n)]
 
     def readmodtab(self, fh, off, n):
         #print 'modtab', off, n
         fh.seek(off)
-        return [dylib_module.from_fileobj(fh) for i in xrange(n)]
+        return [dylib_module.from_fileobj(fh) for i in range(n)]
 
     def readsym(self, fh, off, n):
         #print 'sym', off, n
         fh.seek(off)
         refs = []
-        for i in xrange(n):
+        for i in range(n):
             ref = dylib_reference.from_fileobj(fh)
             isym, flags = divmod(ref.isym_flags, 256)
             refs.append((self.nlists[isym], flags))
@@ -92,4 +92,4 @@ class SymbolTable(object):
     def readrel(self, fh, off, n):
         #print 'rel', off, n
         fh.seek(off)
-        return [relocation_info.from_fileobj(fh) for i in xrange(n)]
+        return [relocation_info.from_fileobj(fh) for i in range(n)]
diff --git a/python/macholib/macholib/__init__.py b/python/macholib/macholib/__init__.py
index df68ce8025..96a3c92174 100644
--- a/python/macholib/macholib/__init__.py
+++ b/python/macholib/macholib/__init__.py
@@ -5,6 +5,5 @@ See the relevant header files in /usr/include/mach-o
 
 And also Apple's documentation.
 """
-from __future__ import print_function
 import pkg_resources
 __version__ = pkg_resources.require('macholib')[0].version
diff --git a/python/macholib/macholib/__main__.py b/python/macholib/macholib/__main__.py
index 5309872cae..c3c8bac527 100644
--- a/python/macholib/macholib/__main__.py
+++ b/python/macholib/macholib/__main__.py
@@ -1,4 +1,3 @@
-from __future__ import print_function, absolute_import
 import os, sys
 
 from macholib.util import is_platform_file
@@ -9,15 +8,15 @@ gCommand = None
 
 def check_file(fp, path, callback):
     if not os.path.exists(path):
-        print('%s: %s: No such file or directory' % (gCommand, path),
+        print('{}: {}: No such file or directory'.format(gCommand, path),
                 file=sys.stderr)
         return 1
 
     try:
         is_plat = is_platform_file(path)
 
-    except IOError as msg:
-        print('%s: %s: %s' % (gCommand, path, msg), file=sys.stderr)
+    except OSError as msg:
+        print('{}: {}: {}'.format(gCommand, path, msg), file=sys.stderr)
         return 1
 
     else:
diff --git a/python/macholib/macholib/_cmdline.py b/python/macholib/macholib/_cmdline.py
index eb44824f99..bcafa67a87 100644
--- a/python/macholib/macholib/_cmdline.py
+++ b/python/macholib/macholib/_cmdline.py
@@ -1,7 +1,6 @@
 """
 Internal helpers for basic commandline tools
 """
-from __future__ import print_function, absolute_import
 import os
 import sys
 
@@ -9,14 +8,14 @@ from macholib.util import is_platform_file
 
 def check_file(fp, path, callback):
     if not os.path.exists(path):
-        print('%s: %s: No such file or directory' % (sys.argv[0], path), file=sys.stderr)
+        print('{}: {}: No such file or directory'.format(sys.argv[0], path), file=sys.stderr)
         return 1
 
     try:
         is_plat = is_platform_file(path)
 
-    except IOError as msg:
-        print('%s: %s: %s' % (sys.argv[0], path, msg), file=sys.stderr)
+    except OSError as msg:
+        print('{}: {}: {}'.format(sys.argv[0], path, msg), file=sys.stderr)
         return 1
 
     else:
diff --git a/python/macholib/macholib/dyld.py b/python/macholib/macholib/dyld.py
index 2e81db7f88..95bdab8159 100644
--- a/python/macholib/macholib/dyld.py
+++ b/python/macholib/macholib/dyld.py
@@ -31,17 +31,10 @@ _DEFAULT_LIBRARY_FALLBACK = [
 ]
 
 # XXX: Is this function still needed?
-if sys.version_info[0] == 2:
-    def _ensure_utf8(s):
-        """Not all of PyObjC and Python understand unicode paths very well yet"""
-        if isinstance(s, unicode):
-            return s.encode('utf8')
-        return s
-else:
-    def _ensure_utf8(s):
-        if s is not None and not isinstance(s, str):
-            raise ValueError(s)
-        return s
+def _ensure_utf8(s):
+    if s is not None and not isinstance(s, str):
+        raise ValueError(s)
+    return s
 
 
 def _dyld_env(env, var):
@@ -153,7 +146,7 @@ def dyld_find(name, executable_path=None, env=None, loader_path=None):
             ), env):
         if os.path.isfile(path):
             return path
-    raise ValueError("dylib %s could not be found" % (name,))
+    raise ValueError("dylib {} could not be found".format(name))
 
 def framework_find(fn, executable_path=None, env=None):
     """
diff --git a/python/macholib/macholib/itergraphreport.py b/python/macholib/macholib/itergraphreport.py
index 453c96e2ac..d886b47256 100644
--- a/python/macholib/macholib/itergraphreport.py
+++ b/python/macholib/macholib/itergraphreport.py
@@ -7,7 +7,7 @@ XXX: need to rewrite this based on altgraph.Dot
 from collections import deque
 
 try:
-    from itertools import imap
+    
 except ImportError:
     imap = map
 
@@ -24,11 +24,11 @@ def itergraphreport(nodes, describe_edge, name='G'):
     def edgevisitor(edge, data, head, tail):
         return {}
 
-    yield 'digraph %s {\n' % (name,)
+    yield 'digraph {} {{\n'.format(name)
     attr = dict(rankdir='LR', concentrate='true')
     cpatt  = '%s="%s"'
-    for item in attr.iteritems():
-        yield '\t%s;\n' % (cpatt % item,)
+    for item in attr.items():
+        yield '\t{};\n'.format(cpatt % item)
 
     # find all packages (subgraphs)
     for (node, data, outgoing, incoming) in nodes:
@@ -37,15 +37,15 @@ def itergraphreport(nodes, describe_edge, name='G'):
     # create sets for subgraph, write out descriptions
     for (node, data, outgoing, incoming) in nodes:
         # update edges
-        for edge in imap(describe_edge, outgoing):
+        for edge in map(describe_edge, outgoing):
             edges.append(edge)
 
         # describe node
-        yield '\t"%s" [%s];\n' % (
+        yield '\t"{}" [{}];\n'.format(
             node,
             ','.join([
                 (cpatt % item) for item in
-                nodevisitor(node, data, outgoing, incoming).iteritems()
+                nodevisitor(node, data, outgoing, incoming.items())
             ]),
         )
 
@@ -64,10 +64,9 @@ def itergraphreport(nodes, describe_edge, name='G'):
             yield edgestr % (
                 head,
                 tail,
-                ','.join([(cpatt % item) for item in attribs.iteritems()]),
+                ','.join([(cpatt % item) for item in attribs.items()]),
             )
 
-    for s in do_graph(graph, '\t'):
-        yield s
+    yield from do_graph(graph, '\t')
 
     yield '}\n'
diff --git a/python/macholib/macholib/mach_o.py b/python/macholib/macholib/mach_o.py
index 1a85c75cf7..8c931d3dbd 100644
--- a/python/macholib/macholib/mach_o.py
+++ b/python/macholib/macholib/mach_o.py
@@ -201,7 +201,7 @@ MH_DYLINKER_SYM = "_mh_dylinker_header"
 (
     MH_OBJECT, MH_EXECUTE, MH_FVMLIB, MH_CORE, MH_PRELOAD, MH_DYLIB,
     MH_DYLINKER, MH_BUNDLE, MH_DYLIB_STUB, MH_DSYM
-) = range(0x1, 0xb)
+) = list(range(0x1, 0xb))
 
 (
     MH_NOUNDEFS, MH_INCRLINK, MH_DYLDLINK, MH_BINDATLOAD, MH_PREBOUND,
@@ -210,7 +210,7 @@ MH_DYLINKER_SYM = "_mh_dylinker_header"
     MH_CANONICAL, MH_WEAK_DEFINES, MH_BINDS_TO_WEAK, MH_ALLOW_STACK_EXECUTION,
     MH_ROOT_SAFE, MH_SETUID_SAFE, MH_NO_REEXPORTED_DYLIBS, MH_PIE,
     MH_DEAD_STRIPPABLE_DYLIB, MH_HAS_TLV_DESCRIPTORS, MH_NO_HEAP_EXECUTION
-) = map((1).__lshift__, range(25))
+) = list(map((1).__lshift__, list(range(25))))
 
 MH_MAGIC = 0xfeedface
 MH_CIGAM = 0xcefaedfe
@@ -310,7 +310,7 @@ class mach_version_helper(Structure):
         ('rev', p_uint8),
     )
     def __str__(self):
-        return '%s.%s.%s' % (self.major, self.minor, self.rev)
+        return '{}.{}.{}'.format(self.major, self.minor, self.rev)
 
 class mach_timestamp_helper(p_uint32):
     def __str__(self):
@@ -372,7 +372,7 @@ LC_REQ_DYLD = 0x80000000
     LC_ID_DYLIB, LC_LOAD_DYLINKER, LC_ID_DYLINKER, LC_PREBOUND_DYLIB,
     LC_ROUTINES, LC_SUB_FRAMEWORK, LC_SUB_UMBRELLA, LC_SUB_CLIENT,
     LC_SUB_LIBRARY, LC_TWOLEVEL_HINTS, LC_PREBIND_CKSUM
-) = range(0x1, 0x18)
+) = list(range(0x1, 0x18))
 
 LC_LOAD_WEAK_DYLIB = LC_REQ_DYLD | 0x18
 
@@ -1282,7 +1282,7 @@ def GET_LIBRARY_ORDINAL(n_desc):
     return (((n_desc) >> 8) & 0xff)
 
 def SET_LIBRARY_ORDINAL(n_desc, ordinal):
-    return (((n_desc) & 0x00ff) | (((ordinal & 0xff) << 8)))
+    return (((n_desc) & 0x00ff) | ((ordinal & 0xff) << 8))
 
 SELF_LIBRARY_ORDINAL = 0x0
 MAX_LIBRARY_ORDINAL = 0xfd
diff --git a/python/macholib/macholib/macho_dump.py b/python/macholib/macholib/macho_dump.py
index 737ce8ebeb..55d35e74b6 100644
--- a/python/macholib/macholib/macho_dump.py
+++ b/python/macholib/macholib/macho_dump.py
@@ -1,6 +1,5 @@
 #!/usr/bin/env python
 
-from __future__ import print_function
 
 import os
 import sys
@@ -29,7 +28,7 @@ def print_file(fp, path):
         arch = CPU_TYPE_NAMES.get(header.header.cputype,
                 header.header.cputype)
 
-        print('    [%s endian=%r size=%r arch=%r]' % (header.__class__.__name__,
+        print('    [{} endian={!r} size={!r} arch={!r}]'.format(header.__class__.__name__,
                 header.endian, sz, arch), file=fp)
         for idx, name, other in header.walkRelocatables():
             if other not in seen:
diff --git a/python/macholib/macholib/macho_find.py b/python/macholib/macholib/macho_find.py
index 0a0cef270b..4ad33c2419 100644
--- a/python/macholib/macholib/macho_find.py
+++ b/python/macholib/macholib/macho_find.py
@@ -1,5 +1,4 @@
 #!/usr/bin/env python
-from __future__ import print_function
 from macholib._cmdline import main as _main
 
 
diff --git a/python/macholib/macholib/macho_standalone.py b/python/macholib/macholib/macho_standalone.py
index ceec82bc96..f7fec5278c 100644
--- a/python/macholib/macholib/macho_standalone.py
+++ b/python/macholib/macholib/macho_standalone.py
@@ -1,5 +1,6 @@
 #!/usr/bin/env python
 
+from __future__ import print_function
 import os
 import sys
 
@@ -9,8 +10,8 @@ from macholib.util import strip_files
 def standaloneApp(path):
     if not (os.path.isdir(path) and os.path.exists(
             os.path.join(path, 'Contents'))):
-        print('%s: %s does not look like an app bundle'
-            % (sys.argv[0], path))
+        print(('%s: %s does not look like an app bundle'
+            % (sys.argv[0], path)))
         sys.exit(1)
     files = MachOStandalone(path).run()
     strip_files(files)
@@ -18,7 +19,7 @@ def standaloneApp(path):
 def main():
     print("WARNING: 'macho_standalone' is deprecated, use 'python -mmacholib standalone' instead")
     if not sys.argv[1:]:
-        raise SystemExit('usage: %s [appbundle ...]' % (sys.argv[0],))
+        raise SystemExit('usage: {} [appbundle ...]'.format(sys.argv[0]))
     for fn in sys.argv[1:]:
         standaloneApp(fn)
 
diff --git a/python/macholib/macholib/ptypes.py b/python/macholib/macholib/ptypes.py
index f1457c91bb..ae51e8aa30 100644
--- a/python/macholib/macholib/ptypes.py
+++ b/python/macholib/macholib/ptypes.py
@@ -6,7 +6,7 @@ import struct
 import sys
 
 try:
-    from itertools import izip, imap
+    
 except ImportError:
     izip, imap = zip, map
 from itertools import chain, starmap
@@ -69,7 +69,7 @@ class MetaPackable(type):
     def from_tuple(cls, tpl, **kw):
         return cls(tpl[0], **kw)
 
-class BasePackable(object):
+class BasePackable:
     _endian_ = '>'
 
     def to_str(self):
@@ -156,7 +156,7 @@ class MetaStructure(MetaPackable):
         dct['_size_'] = size
         dct['_items_'] = items
         dct['_format_'] = format
-        return super(MetaStructure, cls).__new__(cls, clsname, bases, dct)
+        return super().__new__(cls, clsname, bases, dct)
 
     def from_tuple(cls, tpl, **kw):
         values = []
@@ -183,18 +183,18 @@ def _make():
             kwargs = args[0]._objects_
             args = ()
         self._objects_ = {}
-        iargs = chain(izip(self._names_, args), kwargs.items())
+        iargs = chain(zip(self._names_, args), list(kwargs.items()))
         for key, value in iargs:
             if key not in self._names_ and key != "_endian_":
                 raise TypeError
             setattr(self, key, value)
-        for key, typ in izip(self._names_, self._types_):
+        for key, typ in zip(self._names_, self._types_):
             if key not in self._objects_:
                 self._objects_[key] = typ()
 
     @as_method
     def _get_packables(self):
-        for obj in imap(self._objects_.__getitem__, self._names_):
+        for obj in map(self._objects_.__getitem__, self._names_):
             if obj._items_ == 1:
                 yield obj
             else:
@@ -208,21 +208,18 @@ def _make():
     @as_method
     def __cmp__(self, other):
         if type(other) is not type(self):
-            raise TypeError('Cannot compare objects of type %r to objects of type %r' % (type(other), type(self)))
-        if sys.version_info[0] == 2:
-            _cmp = cmp
-        else:
-            def _cmp(a, b):
-                if a < b:
-                    return -1
-                elif a > b:
-                    return 1
-                elif a == b:
-                    return 0
-                else:
-                    raise TypeError()
-
-        for cmpval in starmap(_cmp, izip(self._get_packables(), other._get_packables())):
+            raise TypeError('Cannot compare objects of type {!r} to objects of type {!r}'.format(type(other), type(self)))
+        def _cmp(a, b):
+            if a < b:
+                return -1
+            elif a > b:
+                return 1
+            elif a == b:
+                return 0
+            else:
+                raise TypeError()
+
+        for cmpval in starmap(_cmp, zip(self._get_packables(), other._get_packables())):
             if cmpval != 0:
                 return cmpval
         return 0
@@ -262,7 +259,7 @@ Structure = _make()
 del _make
 
 try:
-    long
+    int
 except NameError:
     long = int
 
@@ -273,9 +270,9 @@ p_uint8 = pypackable('p_uint8', int, 'B')
 p_int16 = pypackable('p_int16', int, 'h')
 p_uint16 = pypackable('p_uint16', int, 'H')
 p_int32 = pypackable('p_int32', int, 'i')
-p_uint32 = pypackable('p_uint32', long, 'I')
-p_int64 = pypackable('p_int64', long, 'q')
-p_uint64 = pypackable('p_uint64', long, 'Q')
+p_uint32 = pypackable('p_uint32', int, 'I')
+p_int64 = pypackable('p_int64', int, 'q')
+p_uint64 = pypackable('p_uint64', int, 'Q')
 p_float = pypackable('p_float', float, 'f')
 p_double = pypackable('p_double', float, 'd')
 
diff --git a/python/macholib/macholib/util.py b/python/macholib/macholib/util.py
index 7f954b6f78..3d5f4f2b70 100644
--- a/python/macholib/macholib/util.py
+++ b/python/macholib/macholib/util.py
@@ -18,16 +18,16 @@ MAGIC_LEN = 4
 STRIPCMD = ['/usr/bin/strip', '-x', '-S', '-']
 
 try:
-    unicode
+    str
 except NameError:
-    unicode = str
+    str = str
 
 
 def fsencoding(s, encoding=sys.getfilesystemencoding()):
     """
     Ensure the given argument is in filesystem encoding (not unicode)
     """
-    if isinstance(s, unicode):
+    if isinstance(s, str):
         s = s.encode(encoding)
     return s
 
@@ -54,7 +54,7 @@ def flipwritable(fn, mode=None):
     os.chmod(fn, stat.S_IWRITE | old_mode)
     return old_mode
 
-class fileview(object):
+class fileview:
     """
     A proxy for file-like objects that exposes a given view of a file
     """
@@ -73,7 +73,7 @@ class fileview(object):
 
     def _checkwindow(self, seekto, op):
         if not (self._start <= seekto <= self._end):
-            raise IOError("%s to offset %d is outside window [%d, %d]" % (
+            raise OSError("%s to offset %d is outside window [%d, %d]" % (
                 op, seekto, self._start, self._end))
 
     def seek(self, offset, whence=0):
@@ -85,7 +85,7 @@ class fileview(object):
         elif whence == 2:
             seekto += self._end
         else:
-            raise IOError("Invalid whence argument to seek: %r" % (whence,))
+            raise OSError("Invalid whence argument to seek: {!r}".format(whence))
         self._checkwindow(seekto, 'seek')
         self._fileobj.seek(seekto)
 
@@ -121,7 +121,7 @@ def mergetree(src, dst, condition=None, copyfn=mergecopy, srcbase=None):
     dst = fsencoding(dst)
     if srcbase is None:
         srcbase = src
-    names = map(fsencoding, os.listdir(src))
+    names = list(map(fsencoding, os.listdir(src)))
     try:
         os.makedirs(dst)
     except OSError:
@@ -142,10 +142,10 @@ def mergetree(src, dst, condition=None, copyfn=mergecopy, srcbase=None):
                     condition=condition, copyfn=copyfn, srcbase=srcbase)
             else:
                 copyfn(srcname, dstname)
-        except (IOError, os.error) as why:
+        except OSError as why:
             errors.append((srcname, dstname, why))
     if errors:
-        raise IOError(errors)
+        raise OSError(errors)
 
 def sdk_normalize(filename):
     """
diff --git a/python/macholib/macholib_tests/binaries/src/build.py b/python/macholib/macholib_tests/binaries/src/build.py
index e2a179c783..a49dc9c6ca 100644
--- a/python/macholib/macholib_tests/binaries/src/build.py
+++ b/python/macholib/macholib_tests/binaries/src/build.py
@@ -1,5 +1,6 @@
 #!/usr/bin/env python
 
+from __future__ import print_function
 import os, sys
 
 
@@ -14,7 +15,7 @@ class Builder (object):
                 getattr(self, nm)()
 
     def build_executable(self):
-        print "Building plain executable"
+        print("Building plain executable")
         pass
 
 
diff --git a/python/macholib/macholib_tests/test_dyld.py b/python/macholib/macholib_tests/test_dyld.py
index 7b41758d96..79fd092807 100644
--- a/python/macholib/macholib_tests/test_dyld.py
+++ b/python/macholib/macholib_tests/test_dyld.py
@@ -9,7 +9,7 @@ if sys.version_info[:2] <= (2,6):
 else:
     import unittest
 
-class DyldPatcher (object):
+class DyldPatcher :
     def __init__(self):
         self.calls = []
         self.patched = {}
@@ -44,7 +44,7 @@ class TestDyld (unittest.TestCase):
 
     def setUp(self):
         self._environ = os.environ
-        os.environ = dict([(k, os.environ[k]) for k in os.environ if 'DYLD' not in k])
+        os.environ = {k: os.environ[k] for k in os.environ if 'DYLD' not in k}
         self._dyld_env = dyld._dyld_env
         self._dyld_image_suffix = dyld.dyld_image_suffix
 
@@ -53,17 +53,10 @@ class TestDyld (unittest.TestCase):
         dyld.dyld_image_suffix = self._dyld_image_suffix
         os.environ = self._environ
 
-    if sys.version_info[0] == 2:
-        def test_ensure_utf8(self):
-            self.assertEqual(dyld._ensure_utf8("hello"), "hello")
-            self.assertEqual(dyld._ensure_utf8("hello".decode('utf-8')), "hello")
-            self.assertEqual(dyld._ensure_utf8(None), None)
-
-    else:
-        def test_ensure_utf8(self):
-            self.assertEqual(dyld._ensure_utf8("hello"), "hello")
-            self.assertEqual(dyld._ensure_utf8(None), None)
-            self.assertRaises(ValueError, dyld._ensure_utf8, b"hello")
+    def test_ensure_utf8(self):
+        self.assertEqual(dyld._ensure_utf8("hello"), "hello")
+        self.assertEqual(dyld._ensure_utf8(None), None)
+        self.assertRaises(ValueError, dyld._ensure_utf8, b"hello")
 
     def test__dyld_env(self):
         new = os.environ
